package com.huimv.entity;

import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.io.Serializable;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 
 * </p>
 *
 * @author author
 * @since 2023-05-11
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("env_electricity")
public class EnvElectricity implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 芯片id
     */
    @TableField("chip_code")
    private String chipCode;

    /**
     * 设备id
     */
    @TableField("device_code")
    private String deviceCode;

    /**
     * 栋舍id
     */
    @TableField("unit_id")
    private String unitId;

    /**
     * 原始值记录
     */
    @TableField("original_value")
    private BigDecimal originalValue;

    /**
     * 处理后的值
     */
    @TableField("handle_value")
    private BigDecimal handleValue;

    /**
     * 应答时间
     */
    @TableField("ask_time")
    private LocalDateTime askTime;

    /**
     * 入库时间
     */
    @TableField("update_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date updateTime;

    @TableField("farm_id")
    private Integer farmId;

    @TableField("other1")
    private String other1;

    @TableField("other2")
    private String other2;

    @TableField("other3")
    private String other3;


}
