package com.huimv.publish;

import com.alibaba.fastjson.JSONObject;
import com.huimv.untils.SpringUtil;
import com.mysql.cj.jdbc.MysqlDataSource;
import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttConnectOptions;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.eclipse.paho.client.mqttv3.persist.MemoryPersistence;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Component;

import java.sql.*;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Configuration
@Component
public class PublishMQTT {

    public static final String HOST = "tcp://192.168.1.68:1883";
    private static final String clientid = "FabuCeShi";
    private MqttClient client;
    private MqttConnectOptions options;

    private String userName = "admin";    //非必须
    private String passWord = "admin";  //非必须

    public void start() {
        try {
            // host为主机名，clientid即连接MQTT的客户端ID，一般以唯一标识符表示，MemoryPersistence设置clientid的保存形式，默认为以内存保存
            client = new MqttClient(HOST, clientid, new MemoryPersistence());
            // MQTT的连接设置
            options = new MqttConnectOptions();
            // 设置是否清空session,这里如果设置为false表示服务器会保留客户端的连接记录，设置为true表示每次连接到服务器都以新的身份连接
            options.setCleanSession(true);
            // 设置连接的用户名
            options.setUserName(userName);
            // 设置连接的密码
            options.setPassword(passWord.toCharArray());
            // 设置超时时间 单位为秒
            options.setConnectionTimeout(10);
            // 设置会话心跳时间 单位为秒 服务器会每隔1.5*20秒的时间向客户端发送个消息判断客户端是否在线，但这个方法并没有重连的机制
            options.setKeepAliveInterval(20);
            //设置断开后重新连接
            options.setAutomaticReconnect(true);
            // 设置回调

            //client.setCallback(new PushCallback());
//            MqttTopic topic = client.getTopic(TOPIC1);
            //遗嘱
           // options.setWill(topic, "关闭前最后的信息".getBytes(), 1, true);
            client.connect(options);

//            DeviceServiceImpl deviceService = SpringUtil.getBean(DeviceServiceImpl.class);
//            System.out.println(deviceService);
//            List<Device> list = deviceService.list();
//            System.out.println(list);
//            Class.forName("com.mysql.cj.jdbc.Driver");
//            JSONObject jsonObject = new JSONObject();
//            Map<String, String> map = new HashMap<>();
//            map.put("year", "2023");
//            map.put("mon", "4");
//            map.put("date", "18");
//            map.put("hour", "2023");
//            map.put("min", "4");
//            map.put("sec", "18");
//            jsonObject.put("sync_time","");
            pubMessage("123132131321","/LG210/D4AD204BAEE4/up");
            System.out.println("发送完成！");
            //向client2发送消息
//            pubMessage("张三,20,男","test");
//            client.unsubscribe("/test/01");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 消息发送
     * @param message
     * @param topic
     */
    public  void pubMessage(String message,String topic){
        MqttMessage mess = new MqttMessage();
        mess.setQos(1);
        mess.setRetained(true);
        mess.setPayload(message.getBytes());
        try {
            client.publish(topic, mess);
        } catch (Exception e) {
            //LOGGER.error(e.getLocalizedMessage());
        }
    }

    /*
     * 连接数据库
     * */
    public void Connect() {
        try {
            Integer test = 2;
            //1.加载驱动
            Class.forName("com.mysql.cj.jdbc.Driver");
            //2.链接数据库
            String url = "jdbc:mysql://localhost:3306/test";
            Connection conn = DriverManager.getConnection(url,"root","123456");
            //3.获取statement对象
            Statement statement = conn.createStatement();
            String sql = "select * from device where id=".concat(String.valueOf(test));
//            String sql =String.format( "select * from device where id= %d",test);
            //4.获取结果集
            ResultSet resultSet = statement.executeQuery(sql);
            resultSet.next();
//            Array device_code = resultSet.getArray("device_code");
            String deviceCode = "";
            deviceCode = resultSet.getString("device_code");
//            //5.从结果集中获取用户名密码
//            String username = "";
//            String password = "";
//            while(resultSet.next()){
//                username = resultSet.getString("username");
//                password = resultSet.getString("password");
//
//                System.out.println("username:" + username + "   " + "password:" + password);
//            }
            System.out.println(deviceCode);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        PublishMQTT client1 = new PublishMQTT();
        client1.start();
//        client1.Connect();
    }
}
