package com.huimv.subscribe;


import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttConnectOptions;
import org.eclipse.paho.client.mqttv3.MqttException;
import org.eclipse.paho.client.mqttv3.persist.MemoryPersistence;
import org.springframework.context.annotation.Configuration;

@Configuration
public class ConsumerMQTT2 {
    public static final String HOST = "tcp://192.168.1.68:1883";
//    public static final String TOPIC1 = "/today/#";//请阅地址
    private static final String clientid = "KeHuDuanCeShi";
    private static MqttClient client;
    private static MqttConnectOptions options;

    private static String userName = "admin";    //非必须
    private static String passWord = "admin";  //非必须

    public void start() {
        try {
            // host为主机名，clientid即连接MQTT的客户端ID，一般以唯一标识符表示，MemoryPersistence设置clientid的保存形式，默认为以内存保存
            client = new MqttClient(HOST, clientid, new MemoryPersistence());
            // MQTT的连接设置
            options = new MqttConnectOptions();
            // 设置是否清空session,这里如果设置为false表示服务器会保留客户端的连接记录，设置为true表示每次连接到服务器都以新的身份连接
            options.setCleanSession(true);
            // 设置连接的用户名
            options.setUserName(userName);
            // 设置连接的密码
            options.setPassword(passWord.toCharArray());
            // 设置超时时间 单位为秒
            options.setConnectionTimeout(10);
            // 设置会话心跳时间 单位为秒 服务器会每隔1.5*20秒的时间向客户端发送个消息判断客户端是否在线，但这个方法并没有重连的机制
            options.setKeepAliveInterval(20);
            //设置断开后重新连接
            options.setAutomaticReconnect(false);
            // 设置回调
            client.setCallback(new PushCallback2());
//            MqttTopic topic = client.getTopic(TOPIC1);
            //setWill方法，如果项目中需要知道客户端是否掉线可以调用该方法。设置最终端口的通知消息
            //遗嘱
           // options.setWill(topic, "关闭前最后的信息".getBytes(), 1, true);
            client.connect(options);

            //订阅消息
//            int[] Qos = {1};//0：最多一次 、1：最少一次 、2：只有一次
//            String[] topic1 = {TOPIC1};
//            client.subscribe(topic1, Qos);
            client.subscribe("/LG210/D4AD204BAEE4/down",1);
//huimv_up_867699060002277

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void test() {
        try {
                // host为主机名，clientid即连接MQTT的客户端ID，一般以唯一标识符表示，MemoryPersistence设置clientid的保存形式，默认为以内存保存
                client = new MqttClient(HOST, clientid, new MemoryPersistence());
                // MQTT的连接设置
                options = new MqttConnectOptions();
                // 设置是否清空session,这里如果设置为false表示服务器会保留客户端的连接记录，设置为true表示每次连接到服务器都以新的身份连接
                options.setCleanSession(true);
                // 设置连接的用户名
                options.setUserName(userName);
                // 设置连接的密码
                options.setPassword(passWord.toCharArray());
                // 设置超时时间 单位为秒
                options.setConnectionTimeout(10);
                // 设置会话心跳时间 单位为秒 服务器会每隔1.5*20秒的时间向客户端发送个消息判断客户端是否在线，但这个方法并没有重连的机制
                options.setKeepAliveInterval(20);
                //设置断开后重新连接
                options.setAutomaticReconnect(false);
                // 设置回调
                client.setCallback(new PushCallback());
//            MqttTopic topic = client.getTopic(TOPIC1);
                //setWill方法，如果项目中需要知道客户端是否掉线可以调用该方法。设置最终端口的通知消息
                //遗嘱
                // options.setWill(topic, "关闭前最后的信息".getBytes(), 1, true);
                client.connect(options);

                //订阅消息
//            int[] Qos = {1};//0：最多一次 、1：最少一次 、2：只有一次
//            String[] topic1 = {TOPIC1};
//            client.subscribe(topic1, Qos);
                client.subscribe("/LG210/D4AD204BAEE4/down", 1);
        } catch (MqttException e) {
            e.printStackTrace();
        }
    }
    public static void main(String[] args) {
        ConsumerMQTT2 client2 = new ConsumerMQTT2();
        client2.start();
    }
}
